AS(1)

NAME
as - assembler

SYNOPSIS
as [ -u ] [ -V ] [ -o objfile ] file ...

DESCRIPTION
As assembles the concatenation of the named files. The options are:

-u  Treat all undefined symbols in the assembly as external globals.

-V  Produce an object suitable for loading into an automatic text overlaid program.

-o  Use objfil for the name of the resultant object. If this is omitted, a.out is used. If no errors occurred during the assembly and if there were no unresolved external references, it is made executable.

The special file name -- serves two purposes. It signals the end of all options and causes stdin to be read for input. Thus it is now possible to pipe data to the assembler:

/lib/cpp -E foo.s | sed -e ';^#;/;' | as -o foo.o --

The file name -- may be placed between normal files, when EOF is detected on stdin the next file in the argument list is opened and read.

If no input files are specified then stdin is read.

FILES
/tmp/atm1    temporary
a.out    object

SEE ALSO
adb(1), ld(1), nm(1), a.out(5)
UNIX Assembler Manual by D. M. Ritchie

DIAGNOSTICS
When an input file cannot be read, its name followed by a question mark is typed and assembly ceases. When syntactic or semantic errors occur, a single-character diagnostic is typed out together with the line number and the file name in which it occurred. Errors in pass 1 cause cancellation of pass 2. The possible errors are:

)    Parentheses error
]    Parentheses error
<    String not terminated properly
*    Indirection used illegally
.    Illegal assignment to `.'
a    Error in address
b    Branch instruction is odd or too remote
e    Error in expression
f    Error in local (`f' or `b') type symbol
g    Garbage (unknown) character
i    End of file inside an if
m    Multiply defined symbol as label
o    Word quantity assembled at odd address
p    `.' different in pass 1 and 2
r    Relocation error
u    Undefined symbol
x    Syntax error

BUGS
Syntax errors can cause incorrect line numbers in following diagnostics.